#include <iostream>

using namespace std;

// --------------------------------------------------------------------

class A
{
public: 
  virtual void f() const { cout << "A "; } 
};

class B : public virtual A
{
public: 
  void f() const { cout << "B "; } 
};

class C : public virtual A
{
public: 
  void f() const { cout << "C "; } 
};

class D : public B, public C
{ 
public: 
	void f() const{ C::f(); }
};

int main()
{
  D d1;
  d1.f();
  return 0;
}

